package at.acdp.urweb;

import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;

public class CountDataInputStream {
    private DataInputStream di;
    private int count;
    public CountDataInputStream(InputStream in) {
       di=new DataInputStream(in);
    }

    public int readInt() throws IOException {
        count+=4;
        return di.readInt();
    }
    public  long readLong() throws IOException {
        count+=8;
        return di.readLong();
    }
    public boolean readBoolean() throws IOException {
        count+=1;
        return di.readBoolean();
    }


    public byte readByte() throws IOException {
        count+=1;
        return di.readByte();
    }

    public double readDouble() throws IOException {
        count+=8;
        return di.readDouble();
    }

    public void readFully(byte[] b) throws IOException {
        count+=b.length;
        di.readFully(b);
    }

    public float readFloat() throws IOException {
        count+=4;
        return di.readFloat();
    }
    public final int readUnsignedByte() throws IOException {
        count+=1;
        return di.readUnsignedByte();
    }



        public int getCount() {
        return count;
    }
}
