package at.acdp.urweb.sclient.data;

import at.acdp.urweb.CountDataInputStream;
import com.eclipsesource.json.JsonObject;

import java.io.DataInputStream;
import java.io.IOException;

public class CartesianInfo implements IRead, IJsonObject {
    public double x,y,z;
    public double rx,ry,rz;
    public double tcpOffsetX,tcpOffsetY, tcpOffsetZ;
    public double tcpOffsetRX,tcpOffsetRY, tcpOffsetRZ;


    public void read(CountDataInputStream di, int size) throws IOException {
        x=di.readDouble();
        y=di.readDouble();
        z=di.readDouble();
        rx=di.readDouble();
        ry=di.readDouble();
        rz=di.readDouble();
        tcpOffsetX=di.readDouble();
        tcpOffsetY=di.readDouble();
        tcpOffsetZ=di.readDouble();
        tcpOffsetRX=di.readDouble();
        tcpOffsetRY=di.readDouble();
        tcpOffsetRZ=di.readDouble();
    }

    @Override
    public JsonObject toJSON() {
        return new JsonObject()
                .add("x", x)
                .add("y", y)
                .add("z", z)
                .add("rx", rx)
                .add("ry", ry)
                .add("rz", rz)
                .add("tcpOffsetX", tcpOffsetX)
                .add("tcpOffsetY", tcpOffsetY)
                .add("tcpOffsetZ", tcpOffsetZ)
                .add("tcpOffsetRX", tcpOffsetRX)
                .add("tcpOffsetRY", tcpOffsetRY)
                .add("tcpOffsetRZ", tcpOffsetRZ)
                ;
    }
}
