package at.acdp.urweb.sclient.data;

import at.acdp.urweb.CountDataInputStream;
import com.eclipsesource.json.JsonObject;

import java.io.DataInputStream;
import java.io.IOException;
import java.util.Arrays;

public class ConfigurationData implements IRead, IJsonObject {

    double[] jointMinLimit=new double[6];
    double[] jointMaxLimit=new double[6];
    double[] jointMaxSpeed=new double[6];
    double[] jointMaxAcceleration= new double[6];
    double vJointDefault;
    double aJointDefault;
    double vToolDefault;
    double aToolDefault;
    double eqRadius;
    double[] dha=new double[6];
    double[] dhd=new double[6];;
    double[] dhAlpha=new double[6];;
    double[] dhTheta=new double[6];;
    int masterboardVersion;
    int controllerBoxType;
    int robotType;
    int robotSubType;

    @Override
    public JsonObject toJSON() {
        return new JsonObject()
                .add("jointMinLimit", Arrays.toString(jointMinLimit))
                .add("jointMaxLimit", Arrays.toString(jointMaxLimit))
                .add("jointMaxSpeed", Arrays.toString(jointMaxSpeed))
                .add("jointMaxAcceleration", Arrays.toString(jointMaxAcceleration))
                .add("vJointDefault", vJointDefault)
                .add("aJointDefault", aJointDefault)
                .add("vToolDefault", vToolDefault)
                .add("aToolDefault", aToolDefault)
                .add("eqRadius", eqRadius)
                .add("dha", Arrays.toString(dha))
                .add("dhd", Arrays.toString(dhd))
                .add("dhAlpha", Arrays.toString(dhAlpha))
                .add("dhTheta", Arrays.toString(dhTheta))
                .add("masterboardVersion", masterboardVersion)
                .add("controllerBoxType", controllerBoxType)
                .add("robotType", robotType)
                .add("robotSubType", robotSubType)
                ;
    }

    public void read(CountDataInputStream di, int size) throws IOException {
        for(int i=0; i<jointMinLimit.length; i++)
            jointMinLimit[i] = di.readDouble();
        for(int i=0; i<jointMaxAcceleration.length; i++)
            jointMaxAcceleration[i] = di.readDouble();
        for(int i=0; i<jointMaxSpeed.length; i++)
            jointMaxSpeed[i] = di.readDouble();
        for(int i=0; i<jointMaxAcceleration.length; i++)
            jointMaxAcceleration[i] = di.readDouble();
        vJointDefault = di.readDouble();
        aJointDefault = di.readDouble();
        vToolDefault = di.readDouble();
        aToolDefault = di.readDouble();
        eqRadius = di.readDouble();
        for(int i=0;i<dha.length;i++)
            dha[i] = di.readDouble();
        for(int i=0;i<dhd.length;i++)
            dhd[i] = di.readDouble();
        for(int i=0;i<dhAlpha.length;i++)
            dhAlpha[i] = di.readDouble();
        for(int i=0;i<dhTheta.length;i++)
            dhTheta[i] = di.readDouble();
        masterboardVersion = di.readInt();
        controllerBoxType = di.readInt();
        robotType = di.readInt();
        robotSubType = di.readInt();
    }

}
